<?php
/**
 * CommonAction.class.php
 * 通用类
 * @author garnono.Hoy
 * Created on 2012-10-25
 * @version mock_client_v2
 */

class CommonAction extends Action
{
	
	public $layout = 'layout:index';//模板
	
	public $table;//数据表
	public $model;//表操作句柄
	public $primary_key = 'id';//主键，保存数据的依据
	public $where = '';//查询条件
	public $fields = '*';//查询字段
	public $order = 'weight asc';//排序
	public $group = '';
	public $g_data;//数据
	public $records_perpage = 10;//每页数据条数
	
	function __construct()
	{
		parent::__construct();
	}
	
	/**
	 * 创建模型，分库处理
	 * 
	 * @param String 数据库的表名称
	 */
	public function CreateModel($name)
	{
//		if (in_array($name, array('record','detail','self_conf','self_detail','self_record'))) {
//			return D($name);
//		} else {
//			return M($name);
//		}
		if (in_array($name, array('record','detail','self_detail','self_conf','self_record'))) {
			return D($name); // 从user表里读取
		} else {
			return M($name);
		}
	}
	
	/**
	 * 获取单条记录
	 */
	public function getOne()
	{
		if ($this->fields == '*')
		{
			$rows = $this->model->where($this->where)->find();
		}
		else
		{
			$rows = $this->model->where($this->where)->getField($this->fields);
		}
		
		$this->fields = '*';
		$this->where = '';
		return $rows;
	}
	
	/**
	 * 获取多条记录
	 */
	public function getAll()
	{
//		$this->htmldump($this->where);
		$rows = $this->model->where($this->where)->order($this->order)->select();
//		$this->getsql();
		$this->where = '';
		$this->order = 'weight asc';
		
		return $rows;
	}
	
	
	/**
	 * 分页操作：需要设置$where,$records_perpage,$model；可提供group、order、fields
	 * 
	 * @return array('lists','all_counts','pager')
	 */
	public function pageList()
	{
		import("@.Util.AjaxPage"); 
		$start_records = (($_GET['p']?$_GET['p']:1)-1)*$this->records_perpage;
		
		$data['all_counts'] = $this->model->where($this->where)->group($this->group)->count();
		
		if ($data['all_counts']<=$start_records)
		{
			$_GET['p'] = ceil($data['all_counts']/$this->records_perpage);
			$start_records = (($_GET['p']?$_GET['p']:1)-1)*$this->records_perpage;
		}
		
		$data['lists'] = $this->model->field($this->fields)->where($this->where)->group($this->group)->order($this->order)->limit("{$start_records},{$this->records_perpage}")->select();
		$Page  = new AjaxPage( $data['all_counts'] , $this->records_perpage , ''); // 实例化分页类传入总记录数和每页显示的记录
		$Page->setConfig('first','首页');
		$Page->setConfig('last','尾页');
		$Page->setConfig('theme' ,"%first% %upPage% %downPage% %end% 当前第 %nowPage%页  共%totalRow%条记录");
//		$this->getsql();
		$Page->setConfig('theme' ," %totalRow%条记录 %nowPage%/%totalPage% 页  %upPage% %linkPage% %downPage%");
		$data['pager']  = $Page->show(); //分页显示输出
		
		return $data;
	}
	
	
	
	/**
	 * 获取时间段：时分秒
	 */
	function duringTime($begin, $end) {
		$duringTime = '';
		if ($begin && $end) {
			$use_time_second = (strtotime($end)-strtotime($begin));
			$use_time_h = intval($use_time_second/3600);
			$use_time_i = intval($use_time_second%3600/60);
			$use_time_s = intval($use_time_second%3600%60);
			if ($use_time_h) $duringTime = $use_time_h.'小时';
			if ($use_time_i) $duringTime = $duringTime.$use_time_i.'分钟';
			if ($use_time_s) $duringTime = $duringTime.$use_time_s.'秒';
		}
		return $duringTime;	
	}
    
    
	/**
	 * 获取子级
	 * 
	 * @param Pointer array childs	存放子级的指针数组
	 * @param int pid	父id
	 * @param int get_level	获取的层数
	 * @param int level 等级标记，默认0，下一级加一
	 */
	public function getChilds(&$childs,$pid = 0, $get_level = 1, $level = 0)
	{
		if ($level < $get_level)
		{
			$this->where['pid'] = $pid;
			$c = M($this->table)->where($this->where)->order($this->order)->select();
			if ($c)
			{
				$level++;
				foreach ($c as $ck=>$cv)
				{
					$cv['L'] = $level;
					$this->getChilds($cv, $cv['id'], $get_level, $level);
					$childs[] = $cv;
				}
				$level--;
			}
		}
	}
	
	/**
	 * 重置config.php中的参数
	 * 
	 * 从session中获取，没有从库中获取存入session
	 */
	public function setC()
	{
		
	}
	
	/**
	 * 报错时处理
	 */	
	function error($e)
	{
	//	error_log(date('Y-m-d H:i:s')."：".$e->getMessage()."  \r\n",3,'log');
		
		header("Location:".$_SERVER['DOCUMENT ROOT']."/50x.html");
	}
	
	/**
	 * 信息打印（调试）
	 */
	public function htmldump($info = "")
	{
		echo "<pre>";print_r($info);echo "</pre>";
	}
	function getsql()
	{
		echo '<pre>';
		echo M()->getLastSql();
		
	}	
	/* 清除session */
	function clearSession()
	{
		
	}
	
	
	public function checkCompact()
	{
		/* $pcid = $_SESSION['pcid'];
		$file = C('VERIFY_FILE');
		$verify_code = C('VERIFY_CODE');
		$code = file_get_contents($file);
		$mere_pcid = md5($pcid.$verify_code);
		$second_str = substr($code,31);//第二部分
		$first_str = substr($code,0,31);//第一部分
		$mpart = substr($mere_pcid,0,31);//当前电脑的前31位
		$other = $this->cutStr(md5($mpart.$second_str),0,31);
		$cids = $this->decodeOpenCrouseCode2($second_str);

		$cd_id = intval($_GET['cd_id'])?$_GET['cd_id']:$_SESSION['cd_id'];

		if($other == $first_str && $second_str !='z' && in_array($cd_id,$cids))
		{
			
		}
		else
		{
			@unlink($file);
			$url = 'Index/login/height/700/pcid/'.$pcid;
			$this->redirect($url);//跳回到登录页面
		} */
	}
	
//	function decodeOpenCrouseCode($opencode)
//	{
//		$opencode = str_replace(array('a','b'),array('"','\\'),$opencode);
//		$c = intval(ord($opencode)) - 32;
//		if ($c < 1) return false;
//		$c = decbin($c);
//		$c_len = strlen($c);
//		for($i=0;$i<$c_len;$i++)
//		{
//			if ($c[$i])
//			{
//				$rs[] = $c_len-$i;
//			}
//		}
//		return $rs;
//	}


function getLastStr($str)
	{
		$str = substr($str,31);
		if($str == 'z')
		{
			$array='z';
		}
		else
		{
			$array = $this->decodeOpenCrouseCode2($str);
		}
		
		return $array;
	}
	
	function saveLastStr($str,$cid=0)
	{	
		$str = substr($str,0,31);
		
		if($cid == 0)
		{
			$str_ = 'z';
		}
		else
		{
			$cid = is_array($cid)?$cid:array($cid);
			$str_= $this->encodeOpenCrouseCode2($cid);
		}
	
		$newstr = $str.$str_;
		return $newstr;
	}
	
	//获取test.log内容
	function getFiles()
	{
		$file = C('VERIFY_FILE');
		$code = file_get_contents($file);
		return $code;
	}
	
	//比较机器码
	function mecode($first,$second,$begin=0,$step=0)
	{		
		$first = $this->cutStr($first,$begin,$step);
		$second = $this->cutStr($second,$begin,$step);
		
		if($first == $second)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	//截取字符串
	function cutStr($str,$begin,$step = 0)
	{
		if($step == 0)
		{
			$str = substr(trim($str),$begin);
		}
		else
		{
			$str = substr(trim($str),$begin,$step);	
		}
		return $str;
	}
    


function encodeOpenCrouseCode($opensubject)
	{
		$num = 32;
		if ($opensubject)
		{
			foreach ($opensubject as $crousecodes)
			{
				if (intval($crousecodes) > 6) break;
				
				$num += pow(2,intval($crousecodes)-1);
			}
		}
		
		if ($num > 32 && $num < 127)
			return str_replace(array('"','\\'),array('a','b'),chr($num));
		else
			return false;
				
	}
	
	function decodeOpenCrouseCode($opencode)
	{
		$opencode = str_replace(array('a','b'),array('"','\\'),$opencode);
		$c = intval(ord($opencode)) - 32;
		if ($c < 1) return false;
		$c = decbin($c);
		$c_len = strlen($c);
		for($i=0;$i<$c_len;$i++)
		{
			if ($c[$i])
			{
				$rs[] = $c_len-$i;
			}
		}
		
		return $rs;
	}
		
	function encodeOpenCrouseCode2($opensubject)
	{
		asort($opensubject);
		$rs = "";
		$num = 0;
		$opensubject_arr = array();
		
		if ($opensubject)
		{
			foreach ($opensubject as $crousecodes)
			{
				$opensubject_arr[$num][] = $crousecodes-6*$num;
				
				if (intval($crousecodes) % 6 == 0)
				{
					$num = intval($crousecodes) / 6;
				}
			}
			
			foreach ($opensubject_arr as $row)
			{
				$r = $this->encodeOpenCrouseCode($row);
				if ($r !== false)
				{
					$rs .= $r;
				}
			}
		}
		
		return $rs;
	}
	
	function decodeOpenCrouseCode2($opencode)
	{
		$rs = array();
		$opencode_arr = str_split($opencode);
		
		foreach ($opencode_arr as $i => $row)
		{
			$r = $this->decodeOpenCrouseCode($row);
			if ($r)
			{
				foreach ($r as $id)
				{
					$rs[] = $id + 6 * $i;
				}
			}
		}
		
		return $rs;
	}

}
 
?>