var Editor = window.Editor || {};

$(function () {
    //容器对象
    Editor._blankSpan = '<span class="blankSpan" style="display:inline-block;width:1px;">&nbsp;</span>';
    Editor._container = null;
    Editor._editorContainer = null;
    Editor._deleteFormula = $('#ul_DeleteFormula');
    Editor._deleteMatrix = $('#btn_DeleteMatrix',window.parent.document);

    //公式容器的html
    Editor._formulaHTML = "<span id='span_formula_{0}' class='isFormula'></span><span id='span_Temp'>&nbsp;</span>" + Editor._blankSpan;
    Editor._formulaNodes = function (html) {
        return $(html);
    };

    Editor._clipboardIsFormula = function () {
        var text = clipboardData.getData('text');

        return text[0] === '$' && text[text.length - 1] === '$';
    };

    //当前正在编辑的公式span的id
    Editor._currentFormulaId = "";

    //当前click事件是否是公式按钮发出。
    Editor._isFormulaClick = false;

    Editor._getCurrentRange = function () {
        var win = window;
        var g =
            win.document.selection ?
				win.document.selection.createRange() :
				win.getSelection().getRangeAt(0);

        return g;
    };

    Editor._insertRangeHtml = function (range, html) {
        var win = window;
        if (win.document.selection) { // IE下
            range.pasteHTML(html);
        }
        else { //非IE
            range.deleteContents();
            var nodes = this._formulaNodes(html);
            for (var i = nodes.length - 1; i >= 0; i--)
                range.insertNode(nodes[i]);
        }
    };

    Editor._getRange = function (area) {
        area.focus();
        var g;
        if (!$.browser.msie) {
            g = Editor.__range;
        } else {
            g = this._getCurrentRange();
        }

        return g;
    };

    Editor._copyCurrentFormula = function () {
        var _ = this, rv = '';
        if (_._currentFormulaId !== '') {
            _.reFocus();
            var latex = $('#' + _._currentFormulaId).find('textarea').val();
            rv = window.API._latexNthroot(latex);
            clipboardData.setData('text', rv);
        }

        return rv;
    };
    Editor._getSelectionHTML = function (range) {
        if (window.getSelection && (window.getSelection()).rangeCount == 1) {
            //			var selection_text = (window.getSelection()).toString();
            //			var range = (window.getSelection()).getRangeAt(0);
            var parent_html = range.commonAncestorContainer.parentElement.innerHTML;
            var first_text = range.startContainer.nodeValue.substr(range.startOffset);
            var last_text = (range.endContainer.nodeValue).substring(0, range.endOffset);
            var start = parent_html.indexOf(first_text);
            var end = parent_html.indexOf(last_text, start + 1) + last_text.length;
            return parent_html.substring(start, end);
        }
        else if (document.selection && document.selection.createRange)
            return range.htmlText;

        return null;
    }

    /*==为了IE8中，公式后面无内容时，向右方向键能将光标移动到公式后面==*/
    Editor._cursorRightElement = function () {
        var _ = this,
			g = _._getRange(_._editorContainer);
        if (g.htmlText != '') {
            g.htmlText += ' ';
            g.moveStart('character', g.htmlText.length - 1);
        }
        g.execCommand("InsertInputHidden", false, 'hidden_temp');
        var isTemp = false,
            formula = null;
        $.each($('#hidden_temp').parent()[0].childNodes, function (i, n) {
            if (n.id == 'hidden_temp')
                isTemp = true;

            if (isTemp && n.id != 'hidden_temp')
                if ($(n).hasClass('isFormula')) {
                    formula = $(n);
                    return false;
                }

            if (n.id != 'hidden_temp')
                isTemp = false;
        });

        $('#hidden_temp').remove();
        return formula;
    };

    Editor._rightArrowDownAfter = null;
    Editor._rightArrowDown = function () {
        var _ = this;
        if (_._currentFormulaId === '' && _._editorContainer) {
            _._rightArrowDownAfter = _._cursorRightElement();
        }
    };

    Editor._rightArrowUp = function () {
        var _ = this;
        if (_._currentFormulaId === '' && _._editorContainer) {
            var rightArrowUpAfter = _._cursorRightElement();
            if (rightArrowUpAfter != null && _._rightArrowDownAfter != null
				&& rightArrowUpAfter[0].id == _._rightArrowDownAfter[0].id) {
				    rightArrowUpAfter.after('<input id="input_temp" />');
				    var inputTemp = $('#input_temp'),
					pre = $(_._blankSpan);
				    inputTemp.before(pre);
				    inputTemp.focus().remove(); //将光标定位到公式后面。
				}
        }
    };

    // 非IE浏览器，在退格时，不能删除公式span，会删除span内的内容，
    // 所以在退格时，判断前面是否为公式，为公式时，删除整个公式。
    Editor._backspace = function () {
        var _ = this;
        if (_._currentFormulaId === '' && _._editorContainer) {
            var range = _._getRange(_._editorContainer);
            _._insertRangeHtml(range, '<input id="temp_Text" type="text"/>');

            var isFormula = false,
				formulaId = '',
				tt = $('#temp_Text');
            $.each(tt.parent()[0].childNodes, function (i, n) {
                if (n.nodeType === 3 && n.nodeValue == '')
                    return true;

                if (isFormula && n.nodeType === 1 && n.id === 'temp_Text')
                    return false;

                (isFormula = (n.nodeType === 1 && $(n).hasClass('isFormula'))) && (formulaId = n.id);
            });

            tt.remove();

            if (isFormula && formulaId !== '') {
                $('#' + formulaId).remove();
                return true;
            }
        }

        return false;
    };
    /*==  ==*/

    Editor._filterClipboardHTML = function () {
        clipboardData.setData('text', clipboardData.getData('text'));

        return clipboardData.getData('text');
    };

    Editor._getMatrix = function () {
        var _ = this;
        if (_._editorContainer != null) {
            var range = _._getRange(_._editorContainer),
				pe = $(range.startContainer ? range.startContainer.parentElement : range.parentElement());

            if (pe.hasClass('Matrix'))
                return pe;
            else
                return pe.parents('div.Matrix');
        }

        return null;
    };

    Editor._inMatrix = function () {
        var _ = this;
        if (_._currentFormulaId !== '')
            return false;

        var matrix = _._getMatrix();

        return matrix && matrix.size() > 0;
    };

    Editor.InsertMatrix = function (row, col) {
        var _ = this,
			id = 'div_Matrix_' + new Date().valueOf();
        var html = '<div id="' + id + '" class="Matrix" style="margin:10px 0;width: _width_px;"><table style="width:100%;border-collapse: collapse;" class="table_Matrix"><tbody>_tr_</tbody></table></div>&nbsp;';

        var trs = '';
        for (var i = 0; i < row; i++) {
            var tds = '';
            for (var j = 0; j < col; j++)
                tds += '<td style="width: 300px;"><div class="MatrixDiv" contentEditable="true"></div></td>';
            trs += '<tr style="height: 100px;">' + tds + '</tr>';
        }
        html = html.replace(/_tr_/g, trs).replace(/_width_/g, col * 300);

        if (_._editorContainer != null) {
            var range = _._getRange(_._editorContainer);

            if (_._currentFormulaId === '') {
                _._insertRangeHtml(range, '<div id="div_matrix_temp"></div>');
                var temp = $('#div_matrix_temp');
                if (temp.parents('div.MatrixDiv').size() > 0) {
                    alert('矩阵不能嵌套在矩阵内。');
                    temp.remove();
                    return;
                } else if (temp.parents('table').size() > 0) {
                    alert('此处不可以插入矩阵。');
                    temp.remove();
                    return;
                }
                _._insertRangeHtml(range, html);
                temp.remove();
                _._editorContainer.focus();

                setTimeout(function () {
                    var body = $(document.body);

                    if (!body.data('mousedown')) {
                        body.mousedown(function (evt) {
                            var matrix = _._getMatrix();
                            var matrix = _._getMatrix();
                            evt = evt ? evt : (window.event ? window.event : null);
                            var elem = $(evt.srcElement ? evt.srcElement : evt.target),
							inMatrix = elem.hasClass('MatrixDiv') || elem.parents('div.MatrixDiv').size() > 0,
							inQueContent = elem.hasClass('queContent') || elem.parents('div.queContent').size() > 0;

                            if (inQueContent)
                                $('div.Matrix:visible').parents('div.queContent').attr('contenteditable', !inMatrix);

                        }).data('mousedown', true);
                    }
                }, 0);
            }
            else
                alert('公式内不可以插入矩阵。');
        } else
            alert('请先定位矩阵插入位置。');
    };

    //在光标位置插入一个公式
    Editor.AddFormula = function () {
        var _ = this,
			win = window;
        var range = _._getRange(_._editorContainer);
        var idSeq = new Date().valueOf();   //每个公式都有个随机编号
        var html = _._formulaHTML.replace(/\{0\}/ig, idSeq)+"&nbsp;";//加上一个空格可以使 光标定位到后面

        _._insertRangeHtml(range, html);
        _._editorContainer.focus();
        _._currentFormulaId = "span_formula_" + idSeq;

        //初始化公式与事件。
        setTimeout(function () {
            _.Editable(_._currentFormulaId);
            $('#span_Temp').remove(); //为了解决插入的公式跑到行尾，公式后面放了一个无用的span。
            if (!$.browser.msie) {
                var bs = $('span.blankSpan');
                bs.after('&nbsp;');
                bs.remove();
            }
        });
    };

    //设置为不可编辑模式
    Editor.Revert = function (id) {
        $("#" + id)
            .data("isEditable", false)
            .mathquill("revert");
    };

    //设置为编辑模式
    Editor.Editable = function (id) {
        $("#" + id)
            .data("isEditable", true)
            .mathquill('editable')
			.mathquill('focus')
            .find("textarea")
            .css("margin-left", "-99999px");    //将公式用到的一个textarea移出左边，因为在IE下，编辑模式时会出控件句柄。

    };

    //指定的公式是否是在编辑模式
    Editor.IsEdit = function (id) {
        return $("#" + id).data("isEditable");
    };

    Editor.InsertWrite = function (q, moveCursor) {
        //未在编辑区
        var _ = this;
        if (_._editorContainer == null) {
            $('#div_FormulaBlock').hide();
            $('#box_div_editor_client').css('display', 'none');
            //$('#box_div_editor_client1').css('display','none');
            alert("请先定位公式插入位置。");
            return;
        }
        if (!_._currentFormulaId || _._currentFormulaId == "")
            _.AddFormula();

        setTimeout(function () {
            try {
                $("#" + _._currentFormulaId)
					.mathquill('focus')
					.mathquill('write', q);
            } catch (e) {
                $("#" + _._currentFormulaId)
						.mathquill('focus')
            }

            q != '';// && window.API.SaveQuesContent();

            _._isFormulaClick = true;
            if (moveCursor && moveCursor > 0) {
                var h = $(":focus").closest(".mathquill-editable");
                var d = !h.length ? null : h.data("[[mathquill internal data]]").block;
                if (d) {
                    for (var i = 0; i < moveCursor; i++)
                        d.cursor.moveLeft();
                }
            }
        });
        $('#div_FormulaBlock').hide();
        $('#box_div_editor_client').css('display', 'none');
        //$('#box_div_editor_client1').css('display','none');
    };

    Editor._findEditableDiv = function (elem) {
        while (elem.tagName.toLowerCase() != "body") {
            if (elem.tagName.toLowerCase() == "div" && elem.getAttribute("contenteditable") == 'true') {
                return elem;
                break;
            }
            elem = elem.parentNode;
        }

        return null;
    };

    Editor.ChangeContainer = function (containerId) {
        var me = this;
        me._container = $('#' + containerId);
        me._editorContainer = null;
        me._currentFormulaId = '';
    };

    Editor.reFocus = function () {
        var me = this;
        if (me._currentFormulaId !== '')
            $('#' + me._currentFormulaId).mathquill('focus');
    };
    
    Editor.showEquation=function(evt){
    	var me = this
        evt = evt ? evt : (window.event ? window.event : null);
        //获得触发该事件的元素
        var elem = evt.srcElement ? evt.srcElement : evt.target;
        var inFormula = false, inContainer = false, inTabContent = false;
        while (elem.tagName.toLowerCase() != "body") {
            if (elem.id.indexOf("span_formula_") == 0) {
                inFormula = true;
                me._currentFormulaId = elem.id;
                //                    break;
            } else if (elem.tagName.toLowerCase() == "div") {
                if (elem.getAttribute("contenteditable") == 'true') {
                    //找到是在编辑容器内
                    inContainer = true;
                    inTabContent = true; //在编辑区域内，一定是在tab容器内。
                    var __elem = $(elem);
                    me._editorContainer = __elem;
                    if (!inFormula) {
                        Editor._getRange(__elem);
                    }
                }
                if (elem.id == inputId) {
                    //在tab页内容区域内。
                    inTabContent = true;
                    break;   //最外层容器已经找到，可以终止循环。
                }
            }
            elem = elem.parentNode;
        }
        if (me._inMatrix()) {
            jQuery('#box_div_editor_client1').css('width', '130px');
        } else {
            jQuery('#box_div_editor_client1').css('width', '125px');
        }
        me._deleteMatrix.parent()[me._inMatrix() ? 'show' : 'hide']();

        if (inFormula) {    //点击的区域在公式内

        } else {
            if (inContainer) {  //编辑容器内
            }

            if (!inTabContent) {
                if (me._currentFormulaId != "") {
                    //点击区域在tab容器内，且如果焦点是从编辑公式编辑器内出去的，将焦点保持在公式内。
                    me.reFocus();
                }
                else
                    me._editorContainer && me._editorContainer.focus();
            } else {
                if (!inContainer)
                    me._editorContainer = null;

                me._currentFormulaId = "";
            }
        }
    }

    Editor.Init = function (containerId) {
    	var me = this,
        // 在firefox中，删除公式按钮被隐藏再显示后，
        // click事件不触发，只能这么移出移进控制显示隐藏了。
			hideDelFormula = function () {
			    me._deleteFormula.css('position', 'absolute');
			},
			showDelFormula = function () {
			    me._deleteFormula.css('position', 'static');
			};
        me.ChangeContainer(containerId);

        me._deleteFormula.find('a').click(function () {
            var f = $('#' + me._currentFormulaId);
            confirm('确定删除当前公式或符号吗？') &&
			(
				f.next('span.blankSpan').remove(),
				f.remove(),
				me._currentFormulaId = ''
			);
        });

        me._deleteMatrix.click(function () {
//            if (confirm('确定要删除当前矩阵吗？')) {
                var matrix = me._getMatrix();
                if (matrix) {
                    var p = matrix.parents('div.queContent');
                    matrix.remove();
                    p.attr('contenteditable', true).focus()

                    me._editorContainer = null; //因为删除矩阵后无法保持住光标位置，所以清除编辑器对象，要求用户重新点击编辑区域。
                }
//            }
        });
        
        

        $(document.body).mouseup(function (evt) {
            //me._deleteFormula.hide();
            hideDelFormula();
            evt = evt ? evt : (window.event ? window.event : null);
            //获得触发该事件的元素
            var elem = evt.srcElement ? evt.srcElement : evt.target;
            var inFormula = false, inContainer = false, inTabContent = false;
            while (elem.tagName.toLowerCase() != "body") {
                if (elem.id.indexOf("span_formula_") == 0) {
                    inFormula = true;
                    me._currentFormulaId = elem.id;
                    //                    break;
                } else if (elem.tagName.toLowerCase() == "div") {
                    if (elem.getAttribute("contenteditable") == 'true') {
                        //找到是在编辑容器内
                        inContainer = true;
                        inTabContent = true; //在编辑区域内，一定是在tab容器内。
                        var __elem = $(elem);
                        me._editorContainer = __elem;
                        if (!inFormula) {
                            Editor._getRange(__elem);
                        }
                    }
                    if (elem.id == inputId) {
                        //在tab页内容区域内。
                        inTabContent = true;
                        break;   //最外层容器已经找到，可以终止循环。
                    }
                }
                elem = elem.parentNode;
            }
            if (me._inMatrix()) {
                jQuery('#box_div_editor_client1').css('width', '130px');
            } else {
                jQuery('#box_div_editor_client1').css('width', '125px');
            }
            me._deleteMatrix.parent()[me._inMatrix() ? 'show' : 'hide']();

            if (inFormula) {    //点击的区域在公式内

            } else {
                if (inContainer) {  //编辑容器内
                }

                if (!inTabContent) {
                    if (me._currentFormulaId != "") {
                        //点击区域在tab容器内，且如果焦点是从编辑公式编辑器内出去的，将焦点保持在公式内。
                        me.reFocus();
                        //me._deleteFormula.show();
                        showDelFormula();
                    }
                    else
                        me._editorContainer && me._editorContainer.focus();
                } else {
                    if (!inContainer)
                        me._editorContainer = null;

                    me._currentFormulaId = "";
                }
            }
            
            //            me._isFormulaClick = false;
        })
        /*.bind('selectstart', function(){
        //编辑区以外不可选中
        var elem = event.srcElement;
        while (elem.tagName.toLowerCase() != "body") {
        if (elem.tagName.toLowerCase() == "div" && $(elem).hasClass('queContent')) {
        return true;
        }
        elem = elem.parentNode;
        }

        return false;
        })*/;
    };
})